#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire2900five4xi.py">
#<abstract4xi abstract = "fires to direction five and to distance 2900"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire2five4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>
       
# -------------------------------------------------------------------------------------------------
# SHOT2FIVE - COORDINATE SIGNS OF SHOOT2FIVE4XI: (X - ,Y + ,Z + )
# -------------------------------------------------------------------------------------------------    
global shot2five29004xi

#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False

shot2five29004xi = {
                1: '-1012x1704y2116z',
                2: '-1018x2548y937z',
                3: '-1042x762y2596z',
                4: '-1063x1842y1970z',
                5: '-1102x720y2583z',
                6: '-1111x1666y2096z',
                7: '-1153x2499y910z',
                8: '-1160x675y2570z',
                9: '-1169x1800y1949z',
                10: '-1209x1622y2076z',
                11: '-1217x625y2556z',
                12: '-121x19y2897z',
                13: '-1271x571y2542z',
                14: '-1273x1752y1927z',
                15: '-1287x2444y882z',
                16: '-1306x1573y2056z',
                17: '-1323x512y2528z',
                18: '-136x878y2760z',
                19: '-1372x450y2514z',
                20: '-1375x1698y1906z',
                21: '-1400x1517y2035z',
                22: '-1417x2380y855z',
                23: '-1418x384y2499z',
                24: '-1461x315y2485z',
                25: '-1475x1638y1884z',
                26: '-1492x1456y2015z',
                27: '-1499x242y2470z',
                28: '-151x16y2895z',
                29: '-1535x166y2454z',
                30: '-1545x2310y827z',
                31: '-1566x87y2439z',
                32: '-1572x1572y1862z',
                33: '-1581x1389y1994z',
                34: '-1592x5y2423z',
                35: '-1665x1500y1839z',
                36: '-1668x1316y1973z',
                37: '-1668x2232y799z',
                38: '-1750x1239y1951z',
                39: '-1756x1422y1817z',
                40: '-1788x2148y771z',
                41: '-180x10y2894z',
                42: '-1829x1156y1930z',
                43: '-1843x1339y1794z',
                44: '-187x896y2751z',
                45: '-1903x2057y743z',
                46: '-1904x1068y1908z',
                47: '-1925x1250y1771z',
                48: '-1974x975y1886z',
                49: '-2003x1156y1748z',
                50: '-2013x1960y715z',
                51: '-2040x878y1864z',
                52: '-205x1952y2134z',
                53: '-2076x1058y1725z',
                54: '-2100x776y1842z',
                55: '-210x1y2892z',
                56: '-2119x1856y687z',
                57: '-2145x955y1701z',
                58: '-2156x671y1819z',
                59: '-2205x561y1796z',
                60: '-2207x847y1678z',
                61: '-2218x1747y659z',
                62: '-2249x449y1774z',
                63: '-2265x735y1654z',
                64: '-2287x333y1751z',
                65: '-2312x1632y630z',
                66: '-2316x620y1630z',
                67: '-2319x214y1727z',
                68: '-2361x501y1606z',
                69: '-2399x1512y602z',
                70: '-2400x380y1582z',
                71: '-241x912y2742z',
                72: '-2425x97y1763z',
                73: '-2432x255y1558z',
                74: '-2457x128y1533z',
                75: '-2476x0y1508z',
                76: '-2480x1387y574z',
                77: '-2555x1258y545z',
                78: '-2622x1125y517z',
                79: '-2682x988y488z',
                80: '-2734x847y460z',
                81: '-2779x704y431z',
                82: '-2816x558y402z',
                83: '-2846x411y373z',
                84: '-2867x262y345z',
                85: '-2880x111y316z',
                86: '-297x924y2732z',
                87: '-308x1803y2250z',
                88: '-310x1959y2114z',
                89: '-317x2675y1073z',
                90: '-34x11y2899z',
                91: '-354x933y2722z',
                92: '-407x1806y2231z',
                93: '-414x938y2712z',
                94: '-416x1961y2094z',
                95: '-459x2665y1046z',
                96: '-474x939y2702z',
                97: '-507x1803y2213z',
                98: '-524x1957y2074z',
                99: '-536x936y2691z',
                100: '-599x929y2680z',
                101: '-600x2647y1019z',
                102: '-608x1795y2194z',
                103: '-632x1946y2054z',
                104: '-63x17y2899z',
                105: '-663x918y2669z',
                106: '-6x2y2899z',
                107: '-709x1781y2175z',
                108: '-727x903y2657z',
                109: '-740x1930y2033z',
                110: '-740x2622y992z',
                111: '-791x884y2646z',
                112: '-810x1761y2156z',
                113: '-849x1907y2012z',
                114: '-854x860y2634z',
                115: '-87x856y2769z',
                116: '-880x2589y965z',
                117: '-911x1735y2136z',
                118: '-918x832y2621z',
                119: '-92x20y2898z',
                120: '-956x1877y1991z',
                121: '-980x799y2609z'}
#"
#"/>

# ----------------------------------------------------------------------------------------------------------------
#<function4xi function = "fire2900five4xi" usage = "target function for charge29004xi4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# ----------------------------------------------------------------------------------------------------------------
def fire2900five4xi(queue2five, consumer_channel2five, publisher_channel2five):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE2900FIVE4XIFIVE4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE2900FIVE4XIFIVE4XI -  QUEUE2FIVE: ", queue2five)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE2900FIVE4XIFIVE4XI -  CONSUMER_CHANNEL2FIVE: ", consumer_channel2five)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE2900FIVE4XIFIVE4XI -  PUBLISHER_CHANNEL2FIVE: ", publisher_channel2five)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE2900FIVE4XIFIVE4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2FIVE: ", queue2five, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2five.put(shot2five29004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE2900FIVE4XIFIVE4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2FIVE: ", queue2five, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE2900FIVE4XIFIVE4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2FIVE: ", queue2five, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE2900FIVE4XIFIVE4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2FIVE: ", publisher_channel2five, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4one = "<ack2put4xi>queue2five8shot2five29004xi</ack2put4xi>"
        else:
            message2send4one = "<nack2put4xi>queue2five8shot2five29004xi</nack2put4xi>" 
            
        publisher_channel2five.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE2900FIVE4XIFIVE4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2FIVE: ", publisher_channel2five, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE2900FIVE4XIFIVE4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2FIVE: ", publisher_channel2five, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE2900FIVE4XIFIVE4XI - RETURNING QUEUE OBJECT QUEUE2FIVE: ", queue2five, " - TIME: ", time4xi())  
        # 
            
    return queue2five    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire2900five4xi.py                             
# -------------------------------------------------------------------------------------------------                